/*
  Name: asciipic.h
  Copyright: 
  Author: 
  Date: 03.03.06 17:20
  Description: Class for ascii output/handling
*/

#ifndef ASCIIPIC_H
#define ASCIIPIC_H

class asciibmp
{
private:
	int w,h;
	char **img;
	int **col;
	//This function must only be called if previous memory was already released!
	void reserveMemory();
public:
	asciibmp();
	asciibmp(const std::string filename);
	asciibmp(int width, int height);
	~asciibmp();
	//Loads bitmap information from external files
	void load(const std::string filename);
	//Deletes the bitmap information
	void destroy();
	//Draws this asciibmp to a BITMAP
	void draw(BITMAP *dest) const;
	//Draws this asciibmp to an other asciibmp
	void draw(asciibmp *dest, int dest_x, int dest_y) const;
	void draw(asciibmp *dest, int source_x, int source_y, int dest_x, int dest_y, int dest_w, int dest_h) const;
	void draw(asciibmp &dest, int dest_x, int dest_y) const;
	void draw(asciibmp &dest, int source_x, int source_y, int dest_x, int dest_y, int dest_w, int dest_h) const;
	//Sets the pixel at position x, y to the given values
	void setPixel(int x, int y, char c, int color);
	//Gets the color value at position x, y
	int getColor(int x, int y) const;
	//Gets the character value at position x, y
	char getCharacter(int x, int y) const;
	//Copies all data from the ref asciibmp
	asciibmp &operator=(const asciibmp &ref);
	void createFrom(const asciibmp &ref);
	//Just standard getters
	int getW() const;
	int getH() const;
	//Resets all fields to blank space and color
	void clear(int color);
	//Creates a blank image with the given width and height
	void create(int width, int height);
	//Writes the given text at the position x, y on the asciibmp
	void textwrite(const std::string text, int x, int y, int color);
	void textwritecenter(const std::string text, int x, int y, int color);
	void textwriteright(const std::string text, int x, int y, int color);
	//Puts a horizontal line on the asciibmp using the supplied character
	void hline(char character, int x1, int y, int x2, int color);
	//Same in vertival
	void vline(char character, int x, int y1, int y2, int color);
};

#endif
