#ifndef ENEMY_H
#define ENEMY_H

#include "object.h"
#include "bullet.h"

extern const int train_w, train_h;

class enemy: public object
{
protected:
	int facing; //0 = straight up up to 7 (clockwise)
	int health; //<= 0 --> dead
	int speed; //moves 1 field every 0,5x logic frames
	public:
	int shoot_speed; //shoots every 0,5x logic frames
	protected:
	int shoot_haswaited;
	int walk_haswaited;	
	int weapon; //0 = mg 1 = rocket launcher
	int ai; //0 = none 1 = shoot but don't move 2 = shoot and move
	
	virtual void fill();	

public:
	enemy() {fill();} //empty instance
	enemy(std::string objectfile); //make a blueprint (used at startup)
	enemy(const enemy &from_blueprint, int posx, int posy, int _facing); //create a "real" instance from a blueprint instance
	~enemy();
	
	virtual void write_objectfile(std::string to, std::string picpath, int health, int speed, int shoot_speed, int weapon, int ai); //picpath: no file extension
	virtual void load_objectfile(std::string from);
	
	bullet* do_ai(int trainx); //react accordingly to ai_level, to be called every logic frame. returns pointer to a bullet or NULL
	
	//setters / getters
	inline int get_facing() const {return facing;}
	inline int get_health() const {return health;}
	inline bool is_dead() const {if(health <= 0) return true; return false;}
	inline bool get_speed() const {return speed;}
	inline bool get_shoot_speed() const
	{
		return shoot_speed;
	}
	inline int get_weapon() const {return weapon;}
	inline int get_ai() const {return ai;}
	
	inline void set_facing(int v) {facing = v;}
	inline void set_health(int v) {health = v;}
	inline void set_speed(int v) {speed = v;}
	inline void set_shoot_speed(int v) {shoot_speed = v;}
	inline void set_ai(int v) {ai = v;}
};

#endif
