/*
  Name: Errors.cpp
  Copyright: Polecatsoft 2005
  Game: Tough Terry
  Author: Master Lenman
  Date: 16.07.05 14:43
  Description: This file contains the functions of the errors namespace,
	  that will show error messages for all kind of errors
*/

#include "StdAfx.h"
#include <string>

using namespace std;

void error::fatalError(string message, bool kill)
{
	if(kill)
	{
		set_gfx_mode(GFX_TEXT, 0,0,0,0);
    	allegro_message(message.c_str());
	    exit(0);
	}
	else
	{
		string line2, line3;
		int position = message.find('\n');
		if(position != string::npos)
		{
			line2 = message.c_str() + position + 1;
			message.erase(position);
			position = line2.find('\n');
			if(position != string::npos)
			{
				line3 = line2.c_str() + position + 1;
				line2.erase(position);
			}
		}
		alert(message.c_str(), line2.c_str(), line3.c_str(), "OK", 0, 0, 0);
	}
}

void error::timerError(bool kill)
{
	fatalError("Error001: Timer could not be initialised", kill);
}

void error::keyboardError(bool kill)
{
	fatalError("Error002: No keyboarddriver found", kill);
}

void error::soundDriverError(bool kill)
{
	fatalError("Error003: Sound driver could not be initialised", kill);
}

void error::graphicModeError(bool kill)
{
	fatalError("Error004: Graphic mode couldn't be set", kill);
}

void error::createError(bool kill)
{
	fatalError("Error005: Creating bitmap failed", kill);
}

void error::loadBitError(string name, bool kill)
{
	fatalError(string("Error006: Loading bitmap \"") + name + string("\" failed"), kill);
}

void error::datafileError(string name, bool kill)
{
	fatalError("Error007: Loading datafile \"" + name + "\" failed", kill);
}

void error::sampleLoadError(string sampleName, bool kill)
{
	fatalError("Error008: Loading sample \"" + sampleName + "\" failed", kill);
}

void error::mapLoadError(string mapName, string reason, bool kill)
{
	fatalError("Error010: Could not load map \"" + mapName + "\" for the following reason:\n" + reason, kill);
}

void error::mouseError(bool kill)
{
	fatalError("Error011: Failed to initialise mouse", kill);
}
	
//Error in network code
void error::networkError(string errorMsg, bool kill)
{
	fatalError("Error012: Network error. Error Message:\n" + errorMsg, kill);
}
